import random;
import math;

def simulate():
    global N, r, mu, theta, T,U, result;
    mean = {"Ruin" : 0, "Time" : 0, "Surplus" : 0}
    var = {"Ruin" : 0, "Time" : 0, "Surplus" : 0}
    for i in range(0,N):
        S = U; t = 0;        
        while (S > 0):
            E = random.expovariate(1.0/mu)
            X = random.expovariate(1.0/theta)
            t = t + E;
            if (t > T):
                break;
            else:
                S = S + r*E - X;        
        if (t > T):
            mean["Surplus"] = mean["Surplus"] + S
            var["Surplus"] = var["Surplus"] + S*S            
        else:
            mean["Ruin"] = mean["Ruin"] + 1
            var["Ruin"] = var["Ruin"] + 1
            mean["Time"] = mean["Time"] + t
            var["Time"] = var["Time"] + t*t
    meanOut = [mean["Ruin"]/(1.0*N),mean["Time"]/(1.0*N),mean["Surplus"]/(1.0*N)]
    stdOut  = [math.sqrt(var["Ruin"]/(1.0*N) - meanOut[0]*meanOut[0]), math.sqrt(var["Time"]/(1.0*N) - meanOut[1]*meanOut[1]), math.sqrt(var["Surplus"]/(1.0*N)-meanOut[2]*meanOut[2])]
    result = [meanOut,stdOut, math.sqrt(N)]

if __name__ == '__main__':
    simulate()   